﻿
Public Class RotaryKnob
    Dim angle As Integer
    Dim maxangle As Integer
    Dim minangle As Integer
    Dim locked As Boolean = False
    Dim melocked As Boolean = False
    Dim knob1ismoving As Boolean = False
    Dim mouseangle As Integer
    Dim curmouseangle As Integer
    Dim knobstartangle As Integer
    Dim oldmouseangle As Integer
    Dim knob As Bitmap

    Public Event ValueChanged(ByVal Value As Integer)

    Public ReadOnly Property value() As Integer
        Get
            Return CInt(Math.Floor(angle / 30))
        End Get
    End Property


    Property haslimits() As Boolean
        Get
            Return locked
        End Get
        Set(ByVal value As Boolean)
            locked = value
        End Set
    End Property
    Property cur_ang() As Integer

        Get
            Return angle
        End Get

        Set(ByVal value As Integer)
            If locked = True Then
                If value > maxangle Then value = maxangle
                If value < minangle Then value = minangle
            End If
            angle = value
        End Set

    End Property
    Property max_ang() As Integer
        Get
            Return maxangle
        End Get
        Set(ByVal value As Integer)
            maxangle = value
        End Set
    End Property
    Property min_ang() As Integer
        Get
            Return minangle
        End Get
        Set(ByVal value As Integer)
            minangle = value
        End Set
    End Property

    Private Sub UserControl1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    End Sub

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        knob = New Bitmap(ImageList1.Images("Knob"))
        e.Graphics.DrawImage(New Bitmap(ImageList1.Images("Back")), 0, 0)
        e.Graphics.ResetTransform()
        e.Graphics.TranslateTransform(50, 50)
        e.Graphics.RotateTransform(angle)
        e.Graphics.DrawImage(knob, -knob.Width \ 2, -knob.Height \ 2)

    End Sub

    Private Sub BufferRefresh_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BufferRefresh.Tick
        Me.Refresh()
        EnableDoubleBuffering()
    End Sub

    Sub EnableDoubleBuffering()
        Me.SetStyle(ControlStyles.OptimizedDoubleBuffer Or ControlStyles.UserPaint Or ControlStyles.AllPaintingInWmPaint, True)
        Me.UpdateStyles()
    End Sub

    Private Sub UserControl11_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        Dim centerofknobx As Integer = CInt(Me.Width / 2)
        Dim centerofknoby As Integer = CInt(Me.Height / 2)

        If knob1ismoving = False Then
            knobstartangle = Me.cur_ang
            mouseangle = CInt(CInt(Math.Atan2((e.Y - centerofknoby), (e.X - centerofknobx)) * (180 / Math.PI)) + 180)
            knob1ismoving = True
        End If
        If melocked = True Then knob1ismoving = False
    End Sub

    Private Sub UserControl11_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        If knob1ismoving = True Then
            Dim centerofknobx As Integer = CInt(Me.Width / 2)
            Dim centerofknoby As Integer = CInt(Me.Height / 2)
            Dim curmouseangle As Integer = CInt(CInt(Math.Atan2((e.Y - centerofknoby), (e.X - centerofknobx)) * (180 / Math.PI)) + 180)
            Dim difference As Integer = curmouseangle - mouseangle
            Dim knobangle As Integer = knobstartangle + difference

            angle = knobangle

            If locked = True Then
                If angle > maxangle Then angle = maxangle
                If angle < minangle Then angle = minangle
            End If

            angle = CInt(Math.Floor(angle / 30) * 30)

            RaiseEvent ValueChanged(CInt(Math.Floor(angle / 30)))


        End If
    End Sub

    Private Sub UserControl11_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseUp
        knob1ismoving = False
    End Sub

    Private Sub RotaryKnob_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseWheel

        If e.Delta > 0 Then
            angle -= 30
        Else
            angle += 30
        End If

        If locked = True Then
            If angle > maxangle Then angle = maxangle
            If angle < minangle Then angle = minangle
        End If


        angle = CInt(Math.Floor(angle / 30) * 30)

        Me.Invalidate()


        RaiseEvent ValueChanged(CInt(Math.Floor(angle / 30)))


    End Sub

End Class
