﻿
Imports System.Collections.Generic
Imports System.Text

Public Class FFT

    Private Shared n As Integer, nu As Integer

    Private Shared Function BitReverse(ByVal j As Integer) As Integer
        Dim j2 As Integer
        Dim j1 As Integer = j
        Dim k As Integer = 0
        For i As Integer = 1 To nu
            j2 = j1 \ 2
            k = 2 * k + j1 - 2 * j2
            j1 = j2
        Next
        Return k
    End Function

    Public Structure FFTResults
        Public Magnitude As Double()
        Public Decibel As Double()
    End Structure


    Public Shared Function Transform(ByRef x As Double()) As FFTResults
        ' Assume n is a power of 2
        n = x.Length - 3
        nu = CInt(Math.Truncate(Math.Log(n) / Math.Log(2)))
        Dim n2 As Integer = n \ 2
        Dim nu1 As Integer = nu - 1
        Dim xre As Double() = New Double(n - 1) {}
        Dim xim As Double() = New Double(n - 1) {}
        Dim magnitude As Double() = New Double(n2 - 1) {}
        Dim decibel As Double() = New Double(n2 - 1) {}
        Dim tr As Double, ti As Double, p As Double, arg As Double, c As Double, s As Double
        For i As Integer = 0 To n - 1
            xre(i) = x(i)
            xim(i) = 0.0F
        Next
        Dim k As Integer = 0
        For l As Integer = 1 To nu
            While k < n
                For i As Integer = 1 To n2
                    p = BitReverse(k >> nu1)
                    arg = 2 * CDbl(Math.PI) * p / n
                    c = CDbl(Math.Cos(arg))
                    s = CDbl(Math.Sin(arg))
                    tr = xre(k + n2) * c + xim(k + n2) * s
                    ti = xim(k + n2) * c - xre(k + n2) * s
                    xre(k + n2) = xre(k) - tr
                    xim(k + n2) = xim(k) - ti
                    xre(k) += tr
                    xim(k) += ti
                    k += 1
                Next
                k += n2
            End While
            k = 0
            nu1 -= 1
            n2 = n2 \ 2
        Next
        k = 0
        Dim r As Integer
        While k < n
            r = BitReverse(k)
            If r > k Then
                tr = xre(k)
                ti = xim(k)
                xre(k) = xre(r)
                xim(k) = xim(r)
                xre(r) = tr
                xim(r) = ti
            End If
            k += 1
        End While

        For i As Integer = 0 To n \ 2 - 1
            magnitude(i) = CSng(Math.Sqrt((xre(i) * xre(i)) + (xim(i) * xim(i))))
            decibel(i) = 10.0 * Math.Log10(CSng(Math.Sqrt((xre(i) * xre(i)) + (xim(i) * xim(i)))))
        Next

        Transform.Magnitude = magnitude
        Transform.Decibel = decibel

        Return Transform

    End Function


End Class
